#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main(){
  while(true){
    long long L, M1, M2, M3, M4;
    cin >> L >> M1 >> M2 >> M3 >> M4;
    if(L == 0 && M1 == 0 && M2 == 0 && M3 == 0 && M4 == 0) break;
    vector<long long> m1(M1), m2(M2), m3(M3), m4(M4);
    for(long long i=0; i<M1; ++i) cin >> m1[i];
    for(long long i=0; i<M2; ++i) cin >> m2[i];
    for(long long i=0; i<M3; ++i) cin >> m3[i];
    for(long long i=0; i<M4; ++i) cin >> m4[i];

    vector<long long> pairs1, pairs2;
    for(long long i=0; i<M1; ++i){
      for(long long j=0; j<M2; ++j){
        pairs1.push_back(m1[i]+m2[j]);
      }
    }
    for(long long i=0; i<M3; ++i){
      for(long long j=0; j<M4; ++j){
        pairs2.push_back(m3[i]+m4[j]);
      }
    }
    sort(pairs1.begin(), pairs1.end());
    sort(pairs2.begin(), pairs2.end());
    long long j = pairs2.size()-1;
    long long sum = 0;
    for(long long i=0; i<pairs1.size(); ++i){
      while(j >= 0 && pairs1[i] + pairs2[j] > L) j--;
      if(j >= 0)sum += j+1;
    }
    cout << sum << '\n';
  }
  return 0;
}
